Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 283596)
+++ channels/chan_sip.c	(working copy)
@@ -9059,17 +9059,24 @@
 {
 	char clen[10];
 	const char *max = NULL;
+	unsigned char prelocked = 0; /* XXX use of this is a temporary fix */
 
-	/* deadlock avoidance */
 	while (dialog->owner && ast_channel_trylock(dialog->owner)) {
-		sip_pvt_unlock(dialog);
+		while (sip_pvt_unlock(dialog) == EPERM && prelocked < 5) {
+			++prelocked;
+			sip_pvt_lock(dialog);
+		}
+
 		usleep(1);
 		sip_pvt_lock(dialog);
 	}
 
 	if (dialog->owner) {
- 		max = pbx_builtin_getvar_helper(dialog->owner, "SIP_MAX_FORWARDS");
+		max = pbx_builtin_getvar_helper(dialog->owner, "SIP_MAX_FORWARDS");
 		ast_channel_unlock(dialog->owner);
+		while (prelocked--) {
+			sip_pvt_unlock(dialog);
+		}
 	}
 
 	/* The channel variable overrides the peer/channel value */
